import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')
create_equation = load('src.main','create_equation')

@points('4.3.1','4.3.2','4.3.3')
class MainTest(unittest.TestCase):
    def test_00_something_is_printed(self):
        self.longMessage = False
        equation1=create_equation([2,7,3,1],['+','+','–'])
        equation2=create_equation([2,7,3,1],['+','+'])
        equation3=create_equation([2,7,3,1],['-'])
        print(equation1)
        print(equation2)
        print(equation3)
        printed = get_stdout()
        if not printed:
            self.fail('Tarkista että funktio toimii ja palauttaa tekstiä!')

    def test_01_prints_right_with_many_operators(self):
        self.longMessage = False
        equation1=create_equation([2,7,3,1],['+','+','–'])
        self.assertEquals(equation1, '2 + 7 + 3 – 1 = 11', msg='Tarkista että funktio toimii.')

    def test_02_prints_right_with_too_few_operators(self):
        self.longMessage = False
        equation2=create_equation([2,7,3,1],['+','+'])
        self.assertEquals(equation2, '', msg='Tarkista että funktio toimii, kun operaattoreita on liian vähän.')

    def test_03_prints_right_with_many_operators(self):
        self.longMessage = False
        equation3=create_equation([2,7,3,1],['-'])
        self.assertEquals(equation3, '2 - 7 - 3 - 1 = -9', msg='Tarkista että funktio toimii kun operaattoreita on vain yksi.')

